procedure ReadDoor32(FName: String);
var
   Sl: TStringList;
begin
     Sl := TStringList.Create;
     Sl.LoadFromFile(FName);

     mUserInfo.ComType := StrToInt(Sl[0]);
     mUserInfo.ComNum := StrToInt(Sl[1]);
     mUserInfo.Baud := StrToInt(Sl[2]);
     mUserInfo.RecNum := StrToInt(Sl[4]);
     if (Pos(' ', Sl[5]) = 0) then
     begin
          mUserInfo.UserF := Sl[5];
          mUserInfo.UserL := 'NLN';
     end else
     begin
          mUserInfo.UserF := Copy(Sl[5], 1, Pos(' ', Sl[5]) - 1);
          mUserInfo.UserL := Copy(Sl[5], Pos(' ', Sl[5]) + 1, Length(Sl[5]) - Pos(' ', Sl[5]));
     end;
     mUserInfo.Handle := Sl[6];
     mUserInfo.Access := StrToInt(Sl[7]);
     mUserInfo.TimeMax := StrToInt(Sl[8]) * 60;

     Sl.Free;
end;

procedure ReadDorinfo(FName: String);
var
   Sl: TStringList;
begin
     Sl := TStringList.Create;
     Sl.LoadFromFile(FName);

     mUserInfo.ComNum := StrToInt(Copy(Sl[3], 4, Length(Sl[3]) - 3));
     mUserInfo.Baud := StrToInt(Copy(Sl[4], 1, Pos(' ', Sl[4]) - 1));
     mUserInfo.UserF := Sl[6];
     mUserInfo.UserL := Sl[7];
     mUserInfo.Access := StrToInt(Sl[10]);
     mUserInfo.TimeMax := StrToInt(Sl[11]) * 60;

     Sl.Free;
end;

procedure ReadInfo(FName: String);
var
   Sl: TStringList;
begin
     Sl := TStringList.Create;
     Sl.LoadFromFile(FName);

     mUserInfo.RecNum := StrToInt(Sl[0]);
     mUserInfo.TimeMax := StrToInt(Sl[4]) * 60;
     mUserInfo.Handle := Sl[5];
     mUserInfo.UserF := Sl[6];
     mUserInfo.UserL := Sl[7];
     mUserInfo.ComNum := StrToInt(Sl[8]);
     mUserInfo.Baud := StrToInt(Sl[9]);

     Sl.Free;
end;

