unit mCmd;

interface

uses
    Classes, MannDoor, MannUtls, SockFunc, SysUtils, Windows,
    mConnect, mGlobal;

procedure HandleInput(S: String);

implementation

var
   Ch: Char;
   I: Integer;
   Sl: TStringList;

procedure HandleInput(S: String);
begin
     S := Trim(S);
     if (S = '') or (S = '/') then
        Exit;

     if (S[1] <> '/') then
     begin
          if (Length(S) = 1) or (UpperCase(S) = 'EXIT') or (UpperCase(S) = 'QUIT') then
             OutP('FIf You Want To Quit, Type /QUIT')
          else
          if (CurChan <> 0) then
          begin
              Out('D<7' + mUserInfo.Handle + '8:7' + ChanList[CurChan] + 'D> 7' + S);
              SockWriteLn('PRIVMSG ' + ChanList[CurChan] + ' :' + S);
          end;
          Exit;
     end;

     Delete(S, 1, 1);
     BreakUp(S, Sl);
     Sl[0] := UpperCase(Sl[0]);

     if (Sl[0] = 'ADMIN') then
     begin
          //ADMIN [server]
          SockWriteLn(S);
     end else
     if (Sl[0] = 'AWAY') then
     begin
          //AWAY [message]
          if (Sl.Count = 1) then
             SockWriteLn(S)
          else
              SockWriteLn('AWAY :' + Join(Sl, 1));
     end else
     if (Sl[0] = 'CLEAR') then
     begin
          //CLEAR
          mClrScr;
     end else
     if (Sl[0] = 'CONNECT') then
     begin
          //CONNECT <server> [port] [remote server]
          SockWriteLn(S);
     end else
     if (Sl[0] = 'CTCP') then
     begin
          //CTCP <nickname> <request>
          if (Sl.Count = 3) then
          begin
               Sl[2] := UpperCase(Sl[2]);
               Out('8[4ctcp8(C' + Sl[1] + '8)] 7' + Sl[2]);
               if (Sl[2] = 'PING') then
                  SockWriteLn('PRIVMSG ' + Sl[1] + ' :' + #1 + Sl[2] + ' ' + IntToStr(SecondsSinceMidnight) + #1)
               else
                   SockWriteLn('PRIVMSG ' + Sl[1] + ' :' + #1 + Sl[2] + #1);
          end;
     end else
     if (Sl[0] = 'HELP') then
     begin
          //HELP
          OutP('Built in help is not currently available');
          OutP('Online help is available at http://www.mannsoft.ca?page=mannirc');
     end else
     if (Sl[0] = 'INFO') then
     begin
          //INFO [server]
          SockWriteLn(S);
     end else
     if (Sl[0] = 'INVITE') then
     begin
          //INVITE <nickname> <channel>
          SockWriteLn(S);
     end else
     if (Sl[0] = 'ISON') then
     begin
          //ISON <nickname>
          SockWriteLn(S);
     end else
     if (Sl[0] = 'JOIN') then
     begin
          //JOIN <channel> [key]
          SockWriteLn(S);
     end else
     if (Sl[0] = 'KICK') then
     begin
          //KICK <channel> <nickname> [reason]
          if (Sl.Count < 3) then
             SockWriteLn('KICK')
          else
          if (Sl.Count = 3) then
             SockWriteLn(S + ' :No Reason Given')
          else
              SockWriteLn('KICK ' + Sl[1] + ' ' + Sl[2] + ' :' + JoinS(Sl, 3));
     end else
     if (Sl[0] = 'KILL') then
     begin
          //KILL <nickname> :[reason]
          if (Sl.Count < 2) then
             SockWriteLn('KILL')
          else
          if (Sl.COunt = 2) then
             SockWriteLn(S + ' :No Reason Given')
          else
              SockWriteLn('KILL ' + Sl[1] + ' :' + Join(Sl, 2));
     end else
     if (Sl[0] = 'LINKS') then
     begin
          //LINKS [remote server]
          SockWriteLn(S);
     end else
     if (Sl[0] = 'LIST') then
     begin
          //LIST <channel>
          SockWriteLn(S);
     end else
     if (Sl[0] = 'ME') then
     begin
          //ME <text>
          if (Sl.Count >= 2) then
          begin
               if (CurChan <> 0) then
               begin
                    Out('8 F' + mUserInfo.Handle + '8:F' + ChanList[CurChan] + ' 7' + Join(Sl, 1));
                    SockWriteLn('PRIVMSG ' + ChanList[CurChan] + ' :' + #1 + 'ACTION ' + Join(Sl, 1) + #1);
               end;
          end;
     end else
     if (Sl[0] = 'MODE') then
     begin
          //MODE <channel>
          //MODE <channel> {[+|-]o|p|s|i|t|n|b|v} [<limit>|<user>|<ban mask>]
          //MODE <nickname>
          //MODE <nickname> {[+|-]i|w|s|o}
          SockWriteLn(S);
     end else
     if (Sl[0] = 'MOTD') then
     begin
          //MOTD
          ShowMOTD := True;
          SockWriteLn('MOTD');
     end else
     if (Sl[0] = 'MSG') then
     begin
          //MSG <nickname> <message>
          if (Sl.Count < 3) then
             SockWriteLn('PRIVMSG')
          else
          begin
               Out('8[4msg8(C' + Sl[1] + '8)] 7' + Join(Sl, 2));
               SockWriteLn('PRIVMSG ' + Sl[1] + ' :' + Join(Sl, 2));
          end;
     end else
     if (Sl[0] = 'NAMES') then
     begin
          //NAMES <channel>
          SockWriteLn(S);
     end else
     if (Sl[0] = 'NICK') then
     begin
          //NICK <nickname>
          SockWriteLn(S);
     end else
     if (Sl[0] = 'NOTICE') then
     begin
          //NOTICE <nickname> <message>
          if (Sl.Count < 3) then
             SockWriteLn('NOTICE')
          else
          begin
               Out('8[4notice8(C' + Sl[1] + '8)] 7' + Join(Sl, 2));
               SockWriteLn('NOTICE ' + Sl[1] + ' :' + Join(Sl, 2));
          end;
     end else
     if (Sl[0] = 'OPER') then
     begin
          //OPER <user> <password>
          SockWriteLn(S);
     end else
     if (Sl[0] = 'PART') then
     begin
          //PART <channel>
          SockWriteLn(S);
     end else
     if (Sl[0] = 'QUIT') then
     begin
          //QUIT [message]
          if (Sl.Count = 1) then
             SockWriteLn('QUIT :' + Copyright)
          else
              SockWriteLn('QUIT :' + Copyright + ' (' + Join(Sl, 1) + ')');
          DoQuit := True;
     end else
     if (Sl[0] = 'REHASH') then
     begin
          //REHASH
          SockWriteLn(S);
     end else
     if (Sl[0] = 'RESTART') then
     begin
          //RESTART
          SockWriteLn(S);
     end else
     if (Sl[0] = 'SERVER') then
     begin
          //SERVER <server> [port]
          if (Sl.Count > 1) and (Ini.ReadBool('general', 'server', false)) then
          begin
               SockWriteLn('QUIT :' + Copyright + ' (Changing Servers)');
               Disconnect;

               if (Sl.Count = 2) then
                  Connect(Sl[1], 6667)
               else
               if (Sl.Count = 3) then
                  Connect(Sl[1], StrToIntDef(Sl[2], 6667));
          end;
     end else
     if (Sl[0] = 'SERVERLIST') then
     begin
          //SERVERLIST
          Sl.Clear;
          Ini.ReadSections(Sl);
          if (Sl.IndexOf('general') <> -1) then
             Sl.Delete(Sl.IndexOf('general'));
          if (Sl.Count > 0) then
          begin
               mClrScr;
               mCrlf;
               mWriteLn('  Available Servers:');
               mCrlf;
               for I := 0 to Sl.Count - 1 do
                   mWriteLn('     ' + Chr(I + 65) + ') ' + Sl[I]);
               mCrlf;
               mWrite('  Your Choice: ');
               repeat
                     Ch := UpCase(mReadKey);
               until (Ord(Ch) - 65 < Sl.Count) and (Ord(Ch) - 65 >= 0) or (Ch = #27);
               mClrScr;
               if (Ch <> #27) then
               begin
                    SockWriteLn('QUIT :' + Copyright + ' (Changing Servers)');
                    Disconnect;
                    DoConnect(Sl[Ord(Ch) - 65]);
               end;
          end;
     end else
     if (Sl[0] = 'SQUIT') then
     begin
          //SQUIT <server> :[reason]
          if (Sl.Count < 2) then
             SockWriteLn('SQUIT')
          else
          if (Sl.Count = 2) then
             SockWriteLn(S + ' :No Reason Given')
          else
              SockWriteLn('SQUIT ' + Sl[1] + ' :' + JoinS(Sl, 2));
     end else
     if (Sl[0] = 'STATS') then
     begin
          //STATS [query] [server]
          SockWriteLn(S);
     end else
     if (Sl[0] = 'TIME') then
     begin
          //TIME [server]
          SockWriteLn(S);
     end else
     if (Sl[0] = 'TOPIC') then
     begin
          //TOPIC <channel> [topic]
          if (Sl.Count < 2) then
             SockWriteLn('TOPIC')
          else
          if (Sl.Count = 2) then
             SockWriteLn(S)
          else
              SockWriteLn('TOPIC ' + Sl[1] + ' :' + JoinS(Sl, 2));
     end else
     if (Sl[0] = 'TRACE') then
     begin
          //TRACE [server]
          SockWriteLn(S);
     end else
     if (Sl[0] = 'USERHOST') then
     begin
          //USERHOST <nickname>
          SockWriteLn(S);
     end else
     if (Sl[0] = 'USERS') then
     begin
          //USERS [server]
          SockWriteLn(S);
     end else
     if (Sl[0] = 'VERSION') then
     begin
          //VERSION [server]
          SockWriteLn(S);
     end else
     if (Sl[0] = 'WALLOPS') then
     begin
          //WALLOPS :<text>
          if (Sl.Count = 1) then
             SockWriteLn(S)
          else
              SockWriteLn('WALLOPS :' + Join(Sl, 1));
     end else
     if (Sl[0] = 'WHO') then
     begin
          //WHO [name] [o]
          SockWriteLn(S);
     end else
     if (Sl[0] = 'WHOIS') then
     begin
          //WHOIS <nickname>
          SockWriteLn(S);
     end else
     if (Sl[0] = 'WHOWAS') then
     begin
          //WHOWAS <nickname>
          SockWriteLn(S);
     end else
         SockWriteLn(S);
end;

initialization
begin
     Sl := TStringList.Create;
end;

finalization
begin
     Sl.Free;
end;

end.
