program _MannIRC_;

uses
    Classes, MannDoor, MannUtls, SockFunc, SysUtils, vpSysLow,
    mCmd, mConnect, mGlobal, mThreads;

procedure DropCarrier;
begin
     SockWriteLn('QUIT :' + Copyright + ' (Caller Dropped Carrier)');
     DefaultDropCarrierProc;
end;

procedure LocalLogin;
var
   Sl: TStringList;
begin
     mUserInfo.UserF := Ini.ReadString('general', 'userf', '');
     mUserInfo.UserL := Ini.ReadString('general', 'userl', '');
     mUserInfo.Handle := Ini.ReadString('general', 'handle', '');
end;

procedure StatusBar;
begin
     FastWrite(Right('TIME: ' + SecToHMS(mUserInfo.TimeLeft) + ' '), 1, 25, 31);
     FastWrite(' ' + mUserInfo.Handle + ' on ' + IRCServer, 1, 25, 31);
end;

procedure TimeOut;
begin
     SockWriteLn('QUIT :' + Copyright + ' (Idle Timelimit Exceeded)');
     DefaultTimeOutProc;
end;

begin
{Initialize MannDoor}
     DropCarrierProc := DropCarrier;
     LocalLoginProc := LocalLogin;
     StatusBarProc := StatusBar;
     TimeOutProc := TimeOut;
     mUserInfo.IdleMax := Ini.ReadInteger('general', 'idletime', 600);
     mStartUp(ParamStr(1), ParamCount = 0);

{Replace spaces in handle with _ and truncate to 8 characters}
     while (Pos(' ', mUserInfo.Handle) > 0) do
     begin
          Insert('_', mUserInfo.Handle, Pos(' ', mUserInfo.Handle));
          Delete(mUserInfo.Handle, Pos(' ', mUserInfo.Handle), 1);
     end;
     if (Length(mUserInfo.Handle) > 8) then
        mUserInfo.Handle := Copy(mUserInfo.Handle, 1, 8);

{Initialize Winsock}
     if (mUserInfo.ComType <> 2) then
        if (SockInit <> 0) then
           OutP('Unable to initialize Winsock.Dll');

{Show Servers List}
     HandleInput('/SERVERLIST');

{Start I/O thread}
     DrawInput;
     StartIOThread;

{Loop until user does /QUIT}
     repeat
           SysCtrlSleep(1);
     until (DoQuit);

{Finalize MannDoor}
     mClose;
end.
